package ch.hevs.kart.comm.transport.tcp;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.SocketException;

import android.content.Context;

import ch.hevs.kart.comm.discovery.Discovery;
import ch.hevs.kart.comm.discovery.DiscoveryListener;
import ch.hevs.kart.comm.discovery.UiThreadDiscoveryListenerWrapper;

public final class TcpDiscovery implements Discovery{
	private class DiscoveryThread extends Thread {
		@Override
		public void run() {
			DatagramPacket udpPacket = new DatagramPacket(new byte[128], 128);
			while(udpScanActive) {
				try {
					udpSocket.receive(udpPacket);
					if (listener != null) {
						listener.entityFoundIndication(TcpDiscovery.this, 
								new TcpDiscoveryEntity(new String(udpPacket.getData(), 0, 
													   udpPacket.getData().length), 
													   udpPacket.getAddress()));
					}
				} catch (IOException e) {
					if (udpScanActive && listener != null) 
						listener.errorIndication(TcpDiscovery.this, e.getMessage());
				}
			}
		}
	}
	
	@Override
	public boolean startDiscovery(final DiscoveryListener listener, final Context context) {
		if (listener == null) return false;
		
		this.listener.setListener(listener);
		
		try {
			udpSocket = new DatagramSocket(0x444);
			udpScanActive = true;
            Thread udpScanThread = new DiscoveryThread();
			udpScanThread.start();
		} catch (SocketException e) {
			listener.errorIndication(this, e.getMessage());
			e.printStackTrace();
			return false;
		}
		
		return true;
	}

	@Override
	public void stopDiscovery() {
		udpScanActive = false;
		udpSocket.disconnect();
		udpSocket.close();
	}
	
	private DatagramSocket udpSocket;
	private boolean udpScanActive = false;
    private final UiThreadDiscoveryListenerWrapper listener =
			new UiThreadDiscoveryListenerWrapper();
}
